import java.util.Arrays;
import java.util.List;

import javax.swing.ImageIcon;
import javax.xml.namespace.QName;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xngr.NodeMarker;

class SimpleDocBookNodeMarker implements NodeMarker {
	ImageIcon icon = new ImageIcon(getClass().getResource("stackframe.gif"));
			
	public String getIdentifier() {
		return "SimpleDocBookNodeMarker";
	}
	
	public XPathExpression getXPathExpression() {
		XPathExpression expression = null;

		XPath path = XPathFactory.newInstance().newXPath();
		
		try {
			expression = path.compile("//*[title]");
		} catch (XPathExpressionException e) {
			e.printStackTrace();
		}
		
		return expression;
	}

	public List<QName> getRootElementNames() {
		return Arrays.asList(new QName[]{new QName("chapter")});
	}

	public String getDescription(Node node) {
		return "Title viewer";
	}

	public String getName(Node node) {
		if (node instanceof Element) {
			NodeList list = ((Element)node).getElementsByTagName("title");
			if (list.getLength() > 0) {
				return ((Element)list.item(0)).getTextContent();
			}
		}
		
		return null;
	}

	public ImageIcon getIcon(Node node) {
		return icon;
	}
}

